/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.Calendar;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.CategoriaPeriodoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaDescuento;
import com.rjconsultores.ventaboletos.entidad.CategoriaPeriodo;

/**
 *
 * @author Administrador
 */
@Repository("categoriaPeriodoDAO")
public class CategoriaPeriodoHibernateDAO
        extends GenericHibernateDAO<CategoriaPeriodo, Integer>
        implements CategoriaPeriodoDAO {

    @Autowired
    public CategoriaPeriodoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<CategoriaPeriodo> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    @Override
    public List<CategoriaPeriodo> buscarPeriodoIntervalo(CategoriaPeriodo cPeriodo) {
    	
    	Calendar feciniciovigencia = Calendar.getInstance();
		feciniciovigencia.setTime(cPeriodo.getFecinicio());
		feciniciovigencia.set(Calendar.MILLISECOND, 0);
		feciniciovigencia.set(Calendar.SECOND, 0);
		
		Calendar fecfinvigencia = Calendar.getInstance();
		fecfinvigencia.setTime(cPeriodo.getFecfin());
		fecfinvigencia.set(Calendar.MILLISECOND, 0);
		fecfinvigencia.set(Calendar.SECOND, 0);
		
		Criteria c = this.getSession().createCriteria(CategoriaPeriodo.class);
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.ge("fecfin", feciniciovigencia.getTime()));
		c.add(Restrictions.le("fecinicio", fecfinvigencia.getTime()));
		c.add(Restrictions.eq("categoriaDescuento", cPeriodo.getCategoriaDescuento()));
		
		
		return c.list();
    }

    @Override
    public List<CategoriaPeriodo> obtenerPorCategoriaDescuento(CategoriaDescuento categoriaDescuento) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("categoriaDescuento", categoriaDescuento));

        return c.list();
    }
}
